

/*
 *  NoNameFS
 *
 *  Copyright (C) 2009 Mike Evans 
 *
 *  NoNameFS has been written to provike discussion on how 
 *  file system naming could be improved so as to be more usable
 *  by human beings.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Authors: Mike Evans <mike@tandem.f9.co.uk>
 *
 */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include <stdio.h>

#include "interface.h"
#include "support.h"
#include "model.h"



/*
 * Create a view and model for the attributes of the file supplied
 * so that they display in the list view of the attributes popup
 */

void set_attributes_model_view(GtkWidget *attributes_popup, selected_file *the_file) {
	
	
	GtkCellRenderer *renderer;
	GtkTreeViewColumn *column;
	GtkTreeIter  iter;
	int i;
	
	GtkWidget *treeview = (GtkWidget *) lookup_widget(GTK_WIDGET(attributes_popup), "attributes_popup_treeview");
	GtkListStore *model = gtk_list_store_new  (2, G_TYPE_STRING, G_TYPE_STRING );
	gtk_tree_view_set_model ( GTK_TREE_VIEW(treeview), GTK_TREE_MODEL(model) );
	
	for ( i=0 ; i < the_file->tag_count ; i++ ) {
		gtk_list_store_append(model, &iter);
		gtk_list_store_set(model, &iter,
					        0, the_file->tags[i].name,
					        1, the_file->tags[i].data,
					        -1);
	}
	
	
	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes ("Attribute",
			                                           renderer,
			                                           "text", 0,
			                                           NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	
	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes ("Data",
			                                           renderer,
			                                           "text", 1,
			                                           NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
	
}

