

/*
 *  NoNameFS
 *
 *  Copyright (C) 2009 Mike Evans 
 *
 *  NoNameFS has been written to provike discussion on how 
 *  file system naming could be improved so as to be more usable
 *  by human beings.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Authors: Mike Evans <mike@tandem.f9.co.uk>
 *
 */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "model.h"

extern  tagfs_state *global_state;

void
on_new1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_save_as1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_main_quit();
}


void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_clear1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_properties1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


gboolean
on_toolbar1_selection_request_event    (GtkWidget       *widget,
                                        GdkEventSelection *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_tagentry_activate                   (GtkEntry        *entry,
                                        gpointer         user_data)
{
	char *tagsline = gtk_editable_get_chars(GTK_EDITABLE(entry),0,-1);
	reset_add_tags_command(global_state,tagsline);
	// refresh the main display by updating the model and view
	find_display_tags(global_state);
	GtkWidget *presenter2 = gtk_widget_get_toplevel(GTK_WIDGET(entry)) ;
	update_model(global_state, presenter2);
	
}




void
on_treeview2_row_activated             (GtkTreeView     *treeview,
                                        GtkTreePath     *path,
                                        GtkTreeViewColumn *column,
                                        gpointer         user_data)
{
	GtkTreeIter iter;
	GtkTreeModel *model;
	GValue gvalue = { 0, };
	GtkEntry *entry;
	const gchar *string;
	char buffer[200];
	
	model = gtk_tree_view_get_model(treeview);   
	gtk_tree_model_get_iter (model, &iter, path);
	gtk_tree_model_get_value( model, &iter, 0, &gvalue);
	string = g_value_get_string(&gvalue);
	add_tags_command(global_state, string);
	find_display_tags(global_state);
	GtkWidget *presenter2 = gtk_widget_get_toplevel(GTK_WIDGET(treeview)) ;
	update_model(global_state, presenter2);
	model_get_tags(global_state, buffer, sizeof(buffer));
	entry = (GtkEntry *) lookup_widget(GTK_WIDGET(presenter2), "tagentry");
	gtk_entry_set_text(entry,buffer);

}

void
on_back_button_clicked                 (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
	GtkEntry *entry;
	char buffer[200];
		
	back_command(global_state);
	find_display_tags(global_state);
	GtkWidget *presenter2 = gtk_widget_get_toplevel(GTK_WIDGET(toolbutton)) ;
	update_model(global_state, presenter2);
	model_get_tags(global_state, buffer, sizeof(buffer));
	entry = (GtkEntry *) lookup_widget(GTK_WIDGET(presenter2), "tagentry");
	gtk_entry_set_text(entry,buffer);
}


void
on_clear_button_clicked                (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
	GtkEntry *entry;
	
	
	tagfs_state_reset(global_state);
	database_get_tags_priority_zero(global_state);
	GtkWidget *presenter2 = gtk_widget_get_toplevel(GTK_WIDGET(toolbutton)) ;
	entry = (GtkEntry *) lookup_widget(GTK_WIDGET(presenter2), "tagentry");
	gtk_entry_set_text(entry,"");
	
	update_model(global_state, presenter2);
	
	
}


void
on_treeview1_cursor_changed            (GtkTreeView     *treeview,
                                        gpointer         user_data)
{
	GtkTreeSelection *selection;
	GtkTreeIter iter;
	GtkTreeModel *model;
	GValue gvalue = { 0, };
	int selected_index;
	
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
	gtk_tree_selection_get_selected(GTK_TREE_SELECTION(selection),&model,&iter);

	gtk_tree_model_get_value( model, &iter, 0, &gvalue);
	selected_index = g_value_get_int(&gvalue);
	global_state->current_cursor_index= selected_index;
	

}


void
on_properties_clicked                  (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{

	GtkWidget *attributes_popup;
	
	
	// find currently selected item - if none do nothing
	if (global_state->current_cursor_index < 0) {
		printf("None selected\n");
		return;
	}
	
	// create an attribute editor for that file
	attributes_popup = create_attributes_popup();
	// TODO create model and view for list showing current tags for file
	set_attributes_model_view(attributes_popup,
			&global_state->selected_files[global_state->current_cursor_index]);
	gtk_widget_show(attributes_popup);
	
}



void
on_attributes_popup_close_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *attributes_popup = gtk_widget_get_toplevel(GTK_WIDGET(button)) ;
	gtk_widget_destroy(GTK_WIDGET(attributes_popup));
}


void
on_attributes_popup_add_button_clicked (GtkButton       *button,
                                        gpointer         user_data)
{

	// TODO get attribute data out of entry box and create tag
	database_add_tag_to_file( &global_state->selected_files[global_state->current_cursor_index].tags[0], 
			&global_state->selected_files[global_state->current_cursor_index]);
}

