
/*
 *  NoNameFS
 *
 *  Copyright (C) 2009 Mike Evans 
 *
 *  NoNameFS has been written to provike discussion on how 
 *  file system naming could be improved so as to be more usable
 *  by human beings.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Authors: Mike Evans <mike@tandem.f9.co.uk>
 *
 */

#include <stdio.h>
#include <dirent.h>

void import_file( const char *directory, char *name) {
	
	printf("importing %s %s\n",directory, name);
	
}

int import_main(int argc, char *argv[]) {
	
	DIR *dir_fd;
	struct dirent *entry;
	
	if (argc < 3 ) {
		printf("syntax:  --import <dirname> \n");
		return 1;
	}
	
	const char *directory = argv[2];
	
	printf("importing directory %s\n",directory);
	
	dir_fd = opendir(directory);
	if ( dir_fd == NULL ) {
		printf("Could not read %s\n",directory);
	}
	
	while ( entry=readdir(dir_fd)  ) {
		if ( entry->d_name[0] != '.' ) {
			if ( entry->d_type == DT_DIR ) {
				printf("subdirectory %s\n", entry->d_name);
			} else if (entry->d_type == DT_REG) {
			    import_file(directory, entry->d_name );
			}
		}
	}
	
	
	
	return 0;
}
